
ECHO OFF
1000 GETMEM DROP
HEX

FORTH DEFINITIONS
RUNTIME
0 ' ARM !


' ABORT LFA>CA *ABORT ! // Patch abort address

: CONSTANT
	CREATE
	LRPUSH
	[ ' [CON] LFA>CA LITERAL ]
	BRLNK		// Make a call to [CON] 
	, 			// Store CONSTANT value from top
;

: VARIABLE
	CREATE
	LRPUSH
	[ ' [VAR] LFA>CA  LITERAL ]
	BRLNK		// Make a call to [VAR] 
	0 , 		// Reserve storage space 
;

: IMMEDIATE	// unlike thumb version - This is ANS93 style - can only change the most recently defined header.
	LATEST @ LFA>FFA F_IMMD OVER C@ OR SWAP C!
;

: ALIAS		// Make alias to an existing word.
	2 ALIGNDP HERE CREATE 4 + DUP C@ F_REMT OR SWAP C! // Set remote bit.
	' LFA>CA ,
;

: ( 29 WORD DROP ;
 IMMEDIATE

COMPILER DEFINITIONS
 
: PATCH			// Insert a branch too *NXT at address @ top
	HERE SWAP ( Save DP for later
	DP !		( Move dp to patch address
	SWAP BR		( Apply the patch
	DP !		( Restore dp 
;

: ELSE 
	HERE
	0 ,	( Reserve space and clear it.	
	SWAP HERE SWAP PATCH
; IMMEDIATE

: THEN
	HERE SWAP PATCH
; IMMEDIATE


: REPEAT
	SWAP	( GET "BEGIN" ADDRESS TO TOP
	BR		( MAKE A BRANCH TO IT
	HERE SWAP
	PATCH	( PATCH THE BRANCH AT "" TO HERE
; IMMEDIATE

: EXIT
	PCPOP
; IMMEDIATE

: BEGIN 
	HERE
; IMMEDIATE

: DO 
	[ ' [DO] LFA>CA LITERAL ]
	BRLNK		// Make a call to [DO]
; IMMEDIATE

: LOOP
	[ ' [LOOP] LFA>CA LITERAL ]
	BRLNK		// Make a call to [LOOP]
; IMMEDIATE

: IF // -- ADDR ; 
	[ ' [IF] LFA>CA LITERAL ]
 BRLNK // At compile time compiler a call to [IF]
	HERE 									// Save here for ELSE or THEN to patch.
	0 ,
; IMMEDIATE
FORTH DEFINITIONS
: ERASE // START LEN --
	0 DO
		0 OVER I + C!
	LOOP
	DROP
;


// RAM OFFSET ERASE

: PATCHIT
// CONTEXT- CONTEXT- -- PATCH MOVED CONTEXT 

	BEGIN
	DUP @ 
	0 >
	IF 							// IF DOES THE SAME AS WHILE;	THREAD --
		DUP @ OFFSET - 			// LINKAD LINK- 
		DUP ROT !
	REPEAT	
	DROP
;

: FOURPATCH
    PATCHIT
	PATCHIT 
	PATCHIT
	PATCHIT
;	

: PATCHVOC
	LFA>CA BPW 2 * + 
	      DUP @ DUP IF OFFSET - OVER ! ELSE DROP THEN		// PATCH *THREAD
	BPW + DUP @ OFFSET - OVER !					// PATCH VOCAB LINK
	BPW + DUP @ OFFSET - SWAP !					// PATCH *NAME
;
RUNTIME
  
 0 ' FORTH LFA>CA BPW 3 *  + !
 
 ' ASSEMBLER LFA>CA BPW 3 * + OFFSET - VOCLINK !

( ' ABORT LFA>CA  *ABORT !

: PATIOABORT 
	BLK@ DUP 4 + CLOSEFP
	BLK 0!
	RP! OP! MP!
	INIT
	OFFSET *PUTLINE -!
	OFFSET *GETLINE -!
	OFFSET DP -!
	OFFSET *ABORT -!
	CONFIGURE 20 [ ' WORD LFA>CA LITERAL ] EXECUTE .S -INCLUDE

 ECHO OFF
ABORT
;

' ARM LFA>CA // REMEMBER THIS 

0 ' FORTH !		// Make this the first {lowest} Word in the dictionary.

FORTH RAM OFFSET CMOVE

COMPILER ' LITERAL LFA>CA BPW 2 * + DUP @ OFFSET - SWAP !
' FORTH OFFSET - PATCHVOC

' COMPILER OFFSET - PATCHVOC
' RUNTIME OFFSET - PATCHVOC
' ASSEMBLER OFFSET - PATCHVOC
' FORTH PATCHVOC

	COMPILER CONTEXT @ OFFSET - 
	ASSEMBLER CONTEXT @ OFFSET - 
	RUNTIME CONTEXT @ OFFSET - 
	FORTH CONTEXT @
	
	FOURPATCH
ECHO ON

PATIOABORT EXTRA.FOR